// DOME/CHATTY/PROVIDENCE/VALNA(PC88) t@CovO

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <direct.h>

#include "d88.h"

D88 disk;
FILE *fp;

static unsigned char dir[0x400*2];
static unsigned char buff[0x400*5*0x50];
static unsigned char id[0x04*5];

bool fsave(char *_fname, unsigned char *_pt, int _size)
{
	fp = fopen(_fname,"wb");
//	printf ("cutting ... %s\n",_fname);
	fwrite(_pt, 1, _size, fp);
	fclose(fp);
	return true;
}

int main(int argc, char *argv[])
{
	static char dirpath[FILENAME_MAX];			// 쐬fBNg
	char fname[FILENAME_MAX];
	char c;
	int mode = 1;
	int dome = 0;
	int diskno,trk,fn,i,fnp;

	if (argc < 2)
	{
		fprintf(stderr, "Usage: %s [d88file] (-d)\n",argv[0]);
		fprintf(stderr, "       -d : TufBNg쐬\n");
		fprintf(stderr, "       -2 : DOME؂o[hɂ\n");
		return 1;
	}
	if (argc>2)
	{
		for (i=2; i<argc; i++)
		{
			if (!strcmp(argv[i],"-d")) mode=0;
			if (!strcmp(argv[i],"-2")) dome=1;
		}
	}

	// t@CJG[ɂȂ
	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();		// fBXNC[W

	for (diskno = 0; diskno < numdisk; diskno++)	// C[W̏
	{
		if (mode)
		{
			sprintf(dirpath,"%03d",diskno);		// fBNg̐
			_mkdir(dirpath);
			_chdir(dirpath);
			printf("\n[%s] -> %s\n",disk.GetDiskName(),dirpath);
		}
		else printf("\n[%s]\n",disk.GetDiskName());

		disk.SelectDisk(diskno);
		disk.SetRecordRange(0x01,0x05);
		// fBNgǂݍ
		disk.ReadDATA(0x01, 0x00, 0x01, 0x01, 0x03, dir, sizeof(dir));

		// Track2ȍ~fBXNۂƓǂݍ
		for (trk=2; trk<0x50; trk++)
		{
			disk.ReadID(trk,id,0x04*5);
			int r_ofs = id[0x02] & 0xf0;	// IDȐ4bit
			disk.SetRecordRange(r_ofs&0x01, r_ofs&0x05);
			disk.ReadDATA(trk, trk/2, trk&1, 0x01|r_ofs, 0x03, &buff[0x400*5*trk], 0x400*5);
		}

		// t@C[v
		for (fn=1; fn<sizeof(dir)/0x10; fn++)
		{
			unsigned char *ent = &dir[fn*0x10];		// fBNgGg𕶎ɂ

			if (dome)
			{
				if (ent[0] == 0x00) continue;		// DOMEp
			}
			else
			{
				if (ent[0] == 0x00) break;			// DOMEȊOp
			}
			fnp=0;

			for (i=0; i<6; i++)
			{
				c = ent[i];				// t@CPo
				if (c == ' ') break;	// 󔒂t@C̏I
				fname[fnp++] = c;		// t@C\
			}
			if (ent[6] != ' ')			// gqKvȂt
			{
				fname[fnp++] = '.';
				for (i=6; i<9; i++)		// 悤Ɋgqo
				{
					c = ent[i];
					if (c == 0x20) break;
					fname[fnp++] = c;
				}
			}
			fname[fnp++] = '\0';		// t@C̍ŌASCIIZ('00h'ŏI悤ɂ

			int track = ent[9];			// t@ĈgbNԍ
			int offset = ent[10];		// ItZbgl
			int size = ent[11];			// TCY(gpZN^)
			int flag = ent[12];			// tO (00h or 80h)

			int filesize = size*0x100;	// t@CTCYvZ (1ZN^256(0x100)byte(N=3))

			if (flag == 0x80)			// tOĂAt@CTCY128byte
			{
				filesize -= 0x80;
			}

			// ʏɕ\
			printf("%-12s %02x %02x %02x %02x\n", fname, track, offset, size, flag);
			fsave(fname,&buff[track*0x400*5 + offset*0x100], filesize);	// t@C؂oď
		}
		if (mode) _chdir("..");		// efBNg
	}
	return 0;
}
